<script>
	import { dashboardStation } from '$lib/preferences';
	import { dashboardEvents, periodSelector, periodConfig } from '$lib/Widgets/stores';
	import { strToDate } from '$lib/date';
	import eventTypes from '/static/eventTypes.json';
	import Badge from '../Badge.svelte';

	let url, period;

	const fetchData = (url, period) => {
		fetch(`${url}?period=${period}`)
			.then(async (req) => await req.json())
			.then((data) => {
				dashboardEvents.set({
					period,
					data: data.map((event) => {
						return {
							date_deb: strToDate(event.date_deb, $periodConfig),
							date_fin: strToDate(event.date_fin, $periodConfig),
							nom: event.nom,
							type: event.type.split(',').map((type) => eventTypes[type]),
							short_desc: event.short_desc
						};
					})
				});
			});
	};

	$: {
		url = `https://api.infoclimat.localhost/api/station/${$dashboardStation.id}/events`;
		switch ($periodSelector) {
			case 'daily':
				period = 'current';
				break;
			case 'monthly':
				period = 'last-5';
				break;
			case 'yearly':
				period = 'all-time';
				break;
		}
		fetchData(url, period);
	}
</script>

<section class="card col-span-4 min-h-[4rem]">
	<h2 class="text-xl font-medium text-gray-900 mb-3">
		10 événements remarquables
		<a class="text-base font-normal text-blue-500 hover:underline" href="/tableau-de-bord/historic">
			voir plus
		</a>
	</h2>
	<div class="pt-4 pb-8">
		<div
			class="flex justify-evenly h-1 bg-gradient-to-r from-blue-200 via-blue-400 to-blue-200 rounded-full"
		>
			{#each $dashboardEvents.data as event, index}
				<div class="group">
					<div
						class="relative h-4 w-4 bg-blue-500 shadow rounded-full mt-[-0.33rem] cursor-pointer"
					>
						<article
							class="absolute top-[3rem] left-[-12rem] group-first:left-0 group-last:left-auto group-last:right-0 z-50 w-[24rem] bg-white border border-lightBlue-500 p-3 shadow rounded-md hidden group-hover:block"
						>
							{#if event.nom}
								<div>
									<h3 class="font-semibold text-gray-900">{event.nom}</h3>
									<p class="font-semibold text-gray-400">Du {event.date_deb} au {event.date_fin}</p>
								</div>
							{:else}
								<h3 class="font-semibold text-gray-900">
									Du {event.date_deb} au {event.date_fin}
								</h3>
							{/if}
							<div class="flex flex-wrap items-center gap-2 mt-1">
								{#each event.type as type}
									<Badge color={type.color}>{type.name}</Badge>
								{/each}
							</div>
							<p class="mt-3">{event.short_desc}</p>
						</article>
						<p
							class="absolute top-[1.25rem] whitespace-nowrap text-gray-500 font-medium transform translate-x-[calc(-50%+0.5rem)]"
						>
							{event.date_deb.split(' ').pop()}
						</p>
					</div>
				</div>
			{/each}
		</div>
	</div>
</section>

<style lang="postcss">
	.card {
		@apply bg-white shadow p-3 rounded-md transition-shadow duration-200 ease-out;
	}
</style>
